<div align="center" ><img width="300" src="https://gw.alicdn.com/tfs/TB18WVWJpzqK1RjSZSgXXcpAVXa-106-120.svg"></div>
<br/>

# NG-ZORRO-Mobile

[![CodeFactor](https://www.codefactor.io/repository/github/ng-zorro/ng-zorro-antd-mobile/badge?style=flat-square)](https://www.codefactor.io/repository/github/ng-zorro/ng-zorro-antd-mobile)
[![Build Status](https://travis-ci.com/NG-ZORRO/ng-zorro-antd-mobile.svg?branch=master)](https://travis-ci.com/NG-ZORRO/ng-zorro-antd-mobile)
[![codecov](https://codecov.io/gh/NG-ZORRO/ng-zorro-antd-mobile/branch/master/graph/badge.svg)](https://codecov.io/gh/NG-ZORRO/ng-zorro-antd-mobile)
[![GitHub Release Date](https://img.shields.io/github/release-date/NG-ZORRO/ng-zorro-antd-mobile.svg?style=flat-square)](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/releases)
[![npm package](https://img.shields.io/npm/v/ng-zorro-antd-mobile.svg?style=flat-square)](https://www.npmjs.org/package/ng-zorro-antd-mobile)
[![NPM downloads](https://img.shields.io/npm/dm/ng-zorro-antd-mobile.svg?style=flat-square)](https://npmjs.org/package/ng-zorro-antd-mobile)
[![GitHub license](https://img.shields.io/github/license/mashape/apistatus.svg?style=flat-square)](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/blob/master/LICENSE)
[![Gitter](https://img.shields.io/gitter/room/ng-zorro/ng-zorro-antd-mobile.svg?style=flat-square)](https://gitter.im/ng-zorro/ng-zorro-antd-mobile)
[![Twitter](https://img.shields.io/badge/Twitter-NG--ZORRO-blue.svg?style=flat-square&logo=twitter)](https://twitter.com/NG_ZORRO)

This is the **Angular** implementation of **Ant Design Mobile** specification, serving **Alibaba** big data wireless service.

[中文 README](README-zh_CN.md)

## Scan QR Code

![ng-zorro-mobile](https://img.alicdn.com/tfs/TB1QMx.JwHqK1RjSZJnXXbNLpXa-260-260.png)

## Features

- An enterprise-class UI design language for **Angular** mobile web applications.
- The UI is fully Configurable and Scalable, easily adapt to all kinds of product style.
- Use **TypeScript** to develop, provide type definition files, support type and attribute smart tips for easy business development.
- Provide "Components are loaded on demand" / "Web page HD display" / "SVG Icon" optimization features, integrated development.
- Support running in Ionic[[Guide]](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/issues/4).

## Environment Support

> with [polyfills](https://angular.io/guide/browser-support)

- `iOS 10.3+`
- `Android 4.4+`

## Angular Support

Now Supports Angular `^15.0.0`.

## Installation

**We recommend using `@angular/cli` to install**，it not only makes development easier，but also allow you to take advantage of the rich ecosystem of angular packages and tooling.

```bash
$ ng new PROJECT_NAME
$ cd PROJECT_NAME
$ ng add ng-zorro-antd-mobile
```

> More information about `@angular/cli` [here](https://github.com/angular/angular-cli).

You can also install `ng-zorro-antd-mobile` with npm or yarn

```bash
$ npm install ng-zorro-antd-mobile
```

## Contributing

[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/pulls)

We welcome all contributions. Please read our [CONTRIBUTING.md](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/blob/master/CONTRIBUTING.md) first.

If you'd like to help us improve **NG-ZORRO-MOBILE**, just create a [Pull Request](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/pulls). Feel free to report bugs and issues [here](https://ng.mobile.ant.design/issue-helper/#/en).

> If you're new to posting issues, we ask that you read [How To Ask Questions The Smart Way](https://www.catb.org/~esr/faqs/smart-questions.html)(This guide does not provide actual support services for this project!) and [How to Ask a Question in Open Source Community](https://github.com/seajs/seajs/issues/545) and [How to Report Bugs Effectively](https://www.chiark.greenend.org.uk/~sgtatham/bugs.html) prior to posting. Well written bug reports help us help you!

## Help from the Community

For questions on how to use **NG-ZORRO-MOBILE**, please post questions to [<img alt="Stack Overflow" src="https://cdn.sstatic.net/Sites/stackoverflow/company/img/logos/so/so-logo.svg?v=2bb144720a66" width="140" />](https://stackoverflow.com/questions/tagged/ng-zorro-mobile) using the `ng-zorro-mobile` tag. If you're not finding what you need on StackOverflow, you can find us on [![Gitter](https://img.shields.io/gitter/room/ng-zorro/ng-zorro-antd-mobile.svg?style=flat-square)](https://gitter.im/ng-zorro/ng-zorro-antd-mobile) as well.

As always, we encourage experienced users to help those who are not familiar with **NG-ZORRO-MOBILE**!

## Users

- [Alibaba](https://www.alibaba.com/)

> If your company or product is using **NG-ZORRO-MOBILE**, please let us know [here](https://github.com/NG-ZORRO/ng-zorro-antd-mobile/issues/3)!

## License

MIT
